﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDateTimeEditorSampleProject
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new MyVM();
        }

        public class MyVM : INotifyPropertyChanged
        {

            #region INotifyPropertyChanged

            public event PropertyChangedEventHandler PropertyChanged;

            private void NotifyPropertyChanged(String info)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(info));
                }
            }

            #endregion

            private ObservableCollection<MyEntry> _entries;
            private TimeSpan _singleTimeSpan;

            public MyVM()
            {
                Entries = new ObservableCollection<MyEntry>();
                Entries.Add(new MyEntry() { MyDateTime = new DateTime(2017, 12, 18, 13, 57, 0), MyTimeSpan = new TimeSpan(13, 57, 0), MyTimeSpan2 = new TimeSpan(13, 57, 0), MyTimeSpan3 = new TimeSpan(13, 57, 0) });
                Entries.Add(new MyEntry() { MyDateTime = new DateTime(2016, 12, 10, 13, 17, 0), MyTimeSpan = new TimeSpan(19, 27, 0), MyTimeSpan2 = new TimeSpan(13, 57, 0), MyTimeSpan3 = new TimeSpan(13, 57, 0) });
                Entries.Add(new MyEntry() { MyDateTime = new DateTime(2014, 12, 11, 13, 54, 0), MyTimeSpan = new TimeSpan(3, 31, 0), MyTimeSpan2 = new TimeSpan(13, 57, 0), MyTimeSpan3 = new TimeSpan(13, 57, 0) });
                SingleTimeSpan = new TimeSpan(12, 10, 07);
            }

            public TimeSpan SingleTimeSpan
            {
                get
                {
                    return _singleTimeSpan;
                }
                set
                {
                    _singleTimeSpan = value;
                    NotifyPropertyChanged(nameof(SingleTimeSpan));
                }
            }

            public ObservableCollection<MyEntry> Entries
            {
                get
                {
                    return _entries;
                }
                set
                {
                    _entries = value;
                    NotifyPropertyChanged(nameof(Entries));
                }
            }


            public class MyEntry : INotifyPropertyChanged
            {

                #region INotifyPropertyChanged

                public event PropertyChangedEventHandler PropertyChanged;

                private void NotifyPropertyChanged(String info)
                {
                    if (PropertyChanged != null)
                    {
                        PropertyChanged(this, new PropertyChangedEventArgs(info));
                    }
                }

                private DateTime _myDateTime;
                private TimeSpan _myTimeSpan;
                private TimeSpan _myTimeSpan2;
                private TimeSpan _myTimeSpan3;

                #endregion
                public DateTime MyDateTime
                {
                    get
                    {
                        return _myDateTime;
                    }
                    set
                    {
                        _myDateTime = value;
                        NotifyPropertyChanged(nameof(MyDateTime));
                    }
                }

                public TimeSpan MyTimeSpan
                {
                    get
                    {
                        return _myTimeSpan;
                    }
                    set
                    {
                        _myTimeSpan = value;
                        NotifyPropertyChanged(nameof(MyTimeSpan));
                    }
                }

                public TimeSpan MyTimeSpan2
                {
                    get
                    {
                        return _myTimeSpan2;
                    }
                    set
                    {
                        _myTimeSpan2 = value;
                        NotifyPropertyChanged(nameof(MyTimeSpan2));
                    }
                }
                public TimeSpan MyTimeSpan3
                {
                    get
                    {
                        return _myTimeSpan3;
                    }
                    set
                    {
                        _myTimeSpan3 = value;
                        NotifyPropertyChanged(nameof(MyTimeSpan3));
                    }
                }
            }
        }
    }
}
